//  Copyright(C):      Advanced Card Systems Ltd
//
//  File:              ACR120 RW EEPROM Sample.csproj
//
//  Description:       Reader Status sample code for 
//					   ACR120 USB Contactless Reader.
//
//  Author:	           Jose Isagani R. Mission
//
//  Date:	           August 16, 2006
//
//  Revision Trail:   (Date/Author/Description)
//                     December 11, 2007/ Aileen Grace L. Sarte/ Converted to Visual C# 2005
//
//==========================================================================================
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace ACR120_RW_EEPROM_Sample
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private int g_rHandle, g_retCode;
		private bool g_isConnected = false;

		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Button btnClrDisp;
		private System.Windows.Forms.Button btnQuit;
		private System.Windows.Forms.ListBox lbMessage;
		private System.Windows.Forms.GroupBox gbConnect;
		private System.Windows.Forms.GroupBox gbFunction;
		private System.Windows.Forms.ComboBox cbPort;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button btnConnect;
		private System.Windows.Forms.Button btnStatus;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		private void DisplayMessage(string Message)
		{
			lbMessage.Items.Add(Message);	
			lbMessage.SelectedIndex = lbMessage.Items.Count - 1;
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainForm));
			this.panel1 = new System.Windows.Forms.Panel();
			this.gbFunction = new System.Windows.Forms.GroupBox();
			this.btnStatus = new System.Windows.Forms.Button();
			this.gbConnect = new System.Windows.Forms.GroupBox();
			this.btnConnect = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.cbPort = new System.Windows.Forms.ComboBox();
			this.lbMessage = new System.Windows.Forms.ListBox();
			this.btnClrDisp = new System.Windows.Forms.Button();
			this.btnQuit = new System.Windows.Forms.Button();
			this.panel1.SuspendLayout();
			this.gbFunction.SuspendLayout();
			this.gbConnect.SuspendLayout();
			this.SuspendLayout();
			// 
			// panel1
			// 
			this.panel1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.panel1.Controls.Add(this.gbFunction);
			this.panel1.Controls.Add(this.gbConnect);
			this.panel1.Controls.Add(this.lbMessage);
			this.panel1.Location = new System.Drawing.Point(8, 8);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(528, 328);
			this.panel1.TabIndex = 0;
			// 
			// gbFunction
			// 
			this.gbFunction.Controls.Add(this.btnStatus);
			this.gbFunction.Location = new System.Drawing.Point(240, 192);
			this.gbFunction.Name = "gbFunction";
			this.gbFunction.Size = new System.Drawing.Size(272, 120);
			this.gbFunction.TabIndex = 2;
			this.gbFunction.TabStop = false;
			this.gbFunction.Text = "Functions";
			// 
			// btnStatus
			// 
			this.btnStatus.Location = new System.Drawing.Point(88, 56);
			this.btnStatus.Name = "btnStatus";
			this.btnStatus.Size = new System.Drawing.Size(104, 23);
			this.btnStatus.TabIndex = 5;
			this.btnStatus.Text = "&Reader Status";
			this.btnStatus.Click += new System.EventHandler(this.btnStatus_Click);
			// 
			// gbConnect
			// 
			this.gbConnect.Controls.Add(this.btnConnect);
			this.gbConnect.Controls.Add(this.label1);
			this.gbConnect.Controls.Add(this.cbPort);
			this.gbConnect.Location = new System.Drawing.Point(8, 192);
			this.gbConnect.Name = "gbConnect";
			this.gbConnect.Size = new System.Drawing.Size(224, 120);
			this.gbConnect.TabIndex = 1;
			this.gbConnect.TabStop = false;
			this.gbConnect.Text = "Connection";
			// 
			// btnConnect
			// 
			this.btnConnect.Location = new System.Drawing.Point(112, 72);
			this.btnConnect.Name = "btnConnect";
			this.btnConnect.Size = new System.Drawing.Size(96, 23);
			this.btnConnect.TabIndex = 1;
			this.btnConnect.Text = "&Connect";
			this.btnConnect.Click += new System.EventHandler(this.btnConnect_Click);
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.ForeColor = System.Drawing.Color.Navy;
			this.label1.Location = new System.Drawing.Point(16, 37);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(72, 23);
			this.label1.TabIndex = 1;
			this.label1.Text = "Select Port";
			// 
			// cbPort
			// 
			this.cbPort.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cbPort.Location = new System.Drawing.Point(88, 32);
			this.cbPort.Name = "cbPort";
			this.cbPort.Size = new System.Drawing.Size(120, 21);
			this.cbPort.TabIndex = 0;
			// 
			// lbMessage
			// 
			this.lbMessage.Location = new System.Drawing.Point(8, 8);
			this.lbMessage.Name = "lbMessage";
			this.lbMessage.Size = new System.Drawing.Size(507, 173);
			this.lbMessage.TabIndex = 0;
			// 
			// btnClrDisp
			// 
			this.btnClrDisp.Location = new System.Drawing.Point(280, 352);
			this.btnClrDisp.Name = "btnClrDisp";
			this.btnClrDisp.Size = new System.Drawing.Size(112, 23);
			this.btnClrDisp.TabIndex = 7;
			this.btnClrDisp.Text = "Clear &Display";
			this.btnClrDisp.Click += new System.EventHandler(this.btnClrDisp_Click);
			// 
			// btnQuit
			// 
			this.btnQuit.Location = new System.Drawing.Point(416, 352);
			this.btnQuit.Name = "btnQuit";
			this.btnQuit.Size = new System.Drawing.Size(112, 23);
			this.btnQuit.TabIndex = 8;
			this.btnQuit.Text = "&Quit";
			this.btnQuit.Click += new System.EventHandler(this.btnQuit_Click);
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.ClientSize = new System.Drawing.Size(544, 389);
			this.Controls.Add(this.btnQuit);
			this.Controls.Add(this.btnClrDisp);
			this.Controls.Add(this.panel1);
			this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "MainForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Reader Status Sample";
			this.Load += new System.EventHandler(this.MainForm_Load);
			this.panel1.ResumeLayout(false);
			this.gbFunction.ResumeLayout(false);
			this.gbConnect.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		static void Main() 
		{
			Application.Run(new MainForm());
		}

		private void btnQuit_Click(object sender, System.EventArgs e)
		{
			ACR120U.ACR120_Close(g_rHandle);
			Application.Exit();
		}

		private void btnClrDisp_Click(object sender, System.EventArgs e)
		{
			lbMessage.Items.Clear();
		}
		private void MainForm_Load(object sender, System.EventArgs e)
		{
			// Form Initialization routine
			DisplayMessage("Program Ready");
			cbPort.Items.Add("USB1");
			cbPort.Items.Add("USB2");
			cbPort.Items.Add("USB3");
			cbPort.Items.Add("USB4");
			cbPort.Items.Add("USB5");
			cbPort.Items.Add("USB6");
			cbPort.Items.Add("USB7");
			cbPort.Items.Add("USB8");
			cbPort.SelectedIndex = 0;
		}

		private void btnConnect_Click(object sender, System.EventArgs e)
		{
		
			//=====================================================================
			// This function opens the port(connection) to ACR120 reader
			//=====================================================================
		
			// Variable declarations
			int ctr = 0;
			byte[] FirmwareVer = new byte[31];
			byte[] FirmwareVer1 = new byte[20];
			byte infolen = 0x00;
			string FirmStr;
			ACR120U.tReaderStatus ReaderStat = new ACR120U.tReaderStatus();

			if (g_isConnected)
			{
			
				DisplayMessage("Device is already connected.");
				return;

			}

			g_rHandle = ACR120U.ACR120_Open(cbPort.SelectedIndex);
			if (g_rHandle != 0)

				DisplayMessage("[X] " + ACR120U.GetErrMsg(g_rHandle));
					
			else
			{
				
				DisplayMessage("Connected to USB" + string.Format("{0}", cbPort.SelectedIndex+1));
				g_isConnected = true;

				//Get the DLL version the program is using
				g_retCode = ACR120U.ACR120_RequestDLLVersion(ref infolen, ref FirmwareVer[0]);
				if (g_retCode < 0)

					DisplayMessage("[X] " + ACR120U.GetErrMsg(g_retCode));
					
				else
				{
					FirmStr = "";
					for(ctr=0;ctr<Convert.ToInt16(infolen)-1;ctr++)
						FirmStr = FirmStr + char.ToString((char)(FirmwareVer[ctr]));
					DisplayMessage("DLL Version : " + FirmStr);
				}
    
			}

		}

		private void btnStatus_Click(object sender, System.EventArgs e)
		{

			//================================================================
			//Check the status of the reader like the firmware version, etc..
			//================================================================

			//Variable Declarations
			byte[] FirmwareVer1 = new byte[20];
			byte[] tmpByte = new byte[4];
			byte[] ByteArray = new byte[20];
			string FirmStr, output;
			ACR120U.tReaderStatus ReaderStat = new ACR120U.tReaderStatus();
			int ctr, indx;
			uint temp;

			//Start of Routine
			g_retCode = ACR120U.ACR120_Status(g_rHandle, ref FirmwareVer1[0], ref ReaderStat);
			if (g_retCode < 0)

				DisplayMessage("[X] " + ACR120U.GetErrMsg(g_retCode));
					
			else
			{

				FirmStr = "";
				for(ctr=0;ctr<20;ctr++)
					if ((FirmwareVer1[ctr] != 0x00) && (FirmwareVer1[ctr] != 0xFF))
						FirmStr = FirmStr + char.ToString((char)(FirmwareVer1[ctr]));
				if (FirmStr != "")
				{
					DisplayMessage("Firmware Version : " + FirmStr);
					DisplayMessage("Card Supported:");
					if ((ReaderStat.CardsSupported[0] & 0x01) == 0x01)
						DisplayMessage("  - Mifare Light");
					if ((ReaderStat.CardsSupported[0] & 0x02) == 0x02)
						DisplayMessage("  - Mifare1K");
					if ((ReaderStat.CardsSupported[0] & 0x04) == 0x04)
						DisplayMessage("  - Mifare 4K");
					if ((ReaderStat.CardsSupported[0] & 0x08) == 0x08)
						DisplayMessage("  - Mifare DESFire");
					if ((ReaderStat.CardsSupported[0] & 0x10) == 0x10)
						DisplayMessage("   - Mifare UltraLight");
					if ((ReaderStat.CardsSupported[0] & 0x20) == 0x20)
						DisplayMessage("  - JCOP30");
					if ((ReaderStat.CardsSupported[0] & 0x40) == 0x40)
						DisplayMessage("  - Shanghai Transport");
					if ((ReaderStat.CardsSupported[0] & 0x80) == 0x80)
						DisplayMessage("  - MPCOS Combi");
					if ((ReaderStat.CardsSupported[1] & 0x01) == 0x01)
						DisplayMessage("  - ISO type B, Calypso");
				}
			}

		}
	}
}