//  Copyright(C):      Advanced Card Systems Ltd
//
//  File:              ACR120 TxData Telegram Sample.csproj
//
//  Description:       TxData Telegram sample code for 
//					   ACR120 USB Contactless Reader.
//
//  Author:	           Jose Isagani R. Mission
//
//  Date:	           August 16, 2006
//
//  Revision Trail:   (Date/Author/Description)
//                     December 11, 2007/ Aileen Grace L. Sarte/ Converted to Visual C# 2005
//============================================================================================
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace ACR120_TxData_Telegram_Sample
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{

		public static int g_rHandle, g_retCode;
		public static byte g_Sec, g_SID;
		private bool g_isConnected = false;

		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.GroupBox gbConnect;
		private System.Windows.Forms.GroupBox gbFunction;
		private System.Windows.Forms.Button btnClrDisp;
		private System.Windows.Forms.Button btnQuit;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.ComboBox cbPort;
		private System.Windows.Forms.Button btnConnect;
		private System.Windows.Forms.Button btnSelect;
		private System.Windows.Forms.Button btnTxDT;
		private System.Windows.Forms.Button btnReset;
		private System.Windows.Forms.Button btnPOn;
		private System.Windows.Forms.Button btnPOff;
		public static System.Windows.Forms.ListBox lbMessage;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		private void DisplayMessage(string Message)
		{
			lbMessage.Items.Add(Message);
			lbMessage.SelectedIndex = lbMessage.Items.Count - 1;
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainForm));
			this.panel1 = new System.Windows.Forms.Panel();
			this.gbFunction = new System.Windows.Forms.GroupBox();
			this.btnTxDT = new System.Windows.Forms.Button();
			this.gbConnect = new System.Windows.Forms.GroupBox();
			this.btnPOff = new System.Windows.Forms.Button();
			this.btnPOn = new System.Windows.Forms.Button();
			this.btnReset = new System.Windows.Forms.Button();
			this.btnSelect = new System.Windows.Forms.Button();
			this.btnConnect = new System.Windows.Forms.Button();
			this.cbPort = new System.Windows.Forms.ComboBox();
			this.label1 = new System.Windows.Forms.Label();
			this.btnClrDisp = new System.Windows.Forms.Button();
			this.btnQuit = new System.Windows.Forms.Button();
			MainForm.lbMessage = new System.Windows.Forms.ListBox();
			this.panel1.SuspendLayout();
			this.gbFunction.SuspendLayout();
			this.gbConnect.SuspendLayout();
			this.SuspendLayout();
			// 
			// panel1
			// 
			this.panel1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.panel1.Controls.Add(MainForm.lbMessage);
			this.panel1.Controls.Add(this.gbFunction);
			this.panel1.Controls.Add(this.gbConnect);
			this.panel1.Location = new System.Drawing.Point(8, 8);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(528, 400);
			this.panel1.TabIndex = 0;
			// 
			// gbFunction
			// 
			this.gbFunction.Controls.Add(this.btnTxDT);
			this.gbFunction.Location = new System.Drawing.Point(240, 192);
			this.gbFunction.Name = "gbFunction";
			this.gbFunction.Size = new System.Drawing.Size(272, 192);
			this.gbFunction.TabIndex = 2;
			this.gbFunction.TabStop = false;
			this.gbFunction.Text = "Functions";
			// 
			// btnTxDT
			// 
			this.btnTxDT.Location = new System.Drawing.Point(80, 88);
			this.btnTxDT.Name = "btnTxDT";
			this.btnTxDT.Size = new System.Drawing.Size(112, 23);
			this.btnTxDT.TabIndex = 6;
			this.btnTxDT.Text = "&TxData Telegram";
			this.btnTxDT.Click += new System.EventHandler(this.btnTxDT_Click);
			// 
			// gbConnect
			// 
			this.gbConnect.Controls.Add(this.btnPOff);
			this.gbConnect.Controls.Add(this.btnPOn);
			this.gbConnect.Controls.Add(this.btnReset);
			this.gbConnect.Controls.Add(this.btnSelect);
			this.gbConnect.Controls.Add(this.btnConnect);
			this.gbConnect.Controls.Add(this.cbPort);
			this.gbConnect.Controls.Add(this.label1);
			this.gbConnect.Location = new System.Drawing.Point(8, 192);
			this.gbConnect.Name = "gbConnect";
			this.gbConnect.Size = new System.Drawing.Size(224, 192);
			this.gbConnect.TabIndex = 1;
			this.gbConnect.TabStop = false;
			this.gbConnect.Text = "Connection";
			// 
			// btnPOff
			// 
			this.btnPOff.Location = new System.Drawing.Point(112, 152);
			this.btnPOff.Name = "btnPOff";
			this.btnPOff.Size = new System.Drawing.Size(96, 21);
			this.btnPOff.TabIndex = 5;
			this.btnPOff.Text = "Power &Off";
			this.btnPOff.Click += new System.EventHandler(this.btnPOff_Click);
			// 
			// btnPOn
			// 
			this.btnPOn.Location = new System.Drawing.Point(112, 128);
			this.btnPOn.Name = "btnPOn";
			this.btnPOn.Size = new System.Drawing.Size(96, 21);
			this.btnPOn.TabIndex = 4;
			this.btnPOn.Text = "&Power On";
			this.btnPOn.Click += new System.EventHandler(this.btnPOn_Click);
			// 
			// btnReset
			// 
			this.btnReset.Location = new System.Drawing.Point(112, 80);
			this.btnReset.Name = "btnReset";
			this.btnReset.Size = new System.Drawing.Size(96, 21);
			this.btnReset.TabIndex = 2;
			this.btnReset.Text = "&Reset";
			this.btnReset.Click += new System.EventHandler(this.btnReset_Click);
			// 
			// btnSelect
			// 
			this.btnSelect.Location = new System.Drawing.Point(112, 104);
			this.btnSelect.Name = "btnSelect";
			this.btnSelect.Size = new System.Drawing.Size(96, 21);
			this.btnSelect.TabIndex = 3;
			this.btnSelect.Text = "&Select";
			this.btnSelect.Click += new System.EventHandler(this.btnSelect_Click);
			// 
			// btnConnect
			// 
			this.btnConnect.Location = new System.Drawing.Point(112, 56);
			this.btnConnect.Name = "btnConnect";
			this.btnConnect.Size = new System.Drawing.Size(96, 21);
			this.btnConnect.TabIndex = 1;
			this.btnConnect.Text = "&Connect";
			this.btnConnect.Click += new System.EventHandler(this.btnConnect_Click);
			// 
			// cbPort
			// 
			this.cbPort.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cbPort.Location = new System.Drawing.Point(88, 24);
			this.cbPort.Name = "cbPort";
			this.cbPort.Size = new System.Drawing.Size(120, 21);
			this.cbPort.TabIndex = 0;
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.ForeColor = System.Drawing.Color.Navy;
			this.label1.Location = new System.Drawing.Point(16, 27);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(72, 24);
			this.label1.TabIndex = 0;
			this.label1.Text = "Select Port";
			this.label1.Click += new System.EventHandler(this.label1_Click);
			// 
			// btnClrDisp
			// 
			this.btnClrDisp.Location = new System.Drawing.Point(280, 424);
			this.btnClrDisp.Name = "btnClrDisp";
			this.btnClrDisp.Size = new System.Drawing.Size(112, 23);
			this.btnClrDisp.TabIndex = 7;
			this.btnClrDisp.Text = "Clear &Display";
			this.btnClrDisp.Click += new System.EventHandler(this.btnClrDisp_Click);
			// 
			// btnQuit
			// 
			this.btnQuit.Location = new System.Drawing.Point(416, 424);
			this.btnQuit.Name = "btnQuit";
			this.btnQuit.Size = new System.Drawing.Size(112, 23);
			this.btnQuit.TabIndex = 8;
			this.btnQuit.Text = "&Quit";
			this.btnQuit.Click += new System.EventHandler(this.btnQuit_Click);
			// 
			// lbMessage
			// 
			MainForm.lbMessage.Location = new System.Drawing.Point(8, 8);
			MainForm.lbMessage.Name = "lbMessage";
			MainForm.lbMessage.Size = new System.Drawing.Size(507, 173);
			MainForm.lbMessage.TabIndex = 3;
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.ClientSize = new System.Drawing.Size(544, 462);
			this.Controls.Add(this.btnQuit);
			this.Controls.Add(this.btnClrDisp);
			this.Controls.Add(this.panel1);
			this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "MainForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "TxData Telegram Sample";
			this.Load += new System.EventHandler(this.MainForm_Load);
			this.panel1.ResumeLayout(false);
			this.gbFunction.ResumeLayout(false);
			this.gbConnect.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}

		private void btnClrDisp_Click(object sender, System.EventArgs e)
		{
			lbMessage.Items.Clear();
		}

		private void btnQuit_Click(object sender, System.EventArgs e)
		{
			ACR120U.ACR120_Close(g_rHandle);
			Application.Exit();
		}

		private void label1_Click(object sender, System.EventArgs e)
		{
		
		}

		private void MainForm_Load(object sender, System.EventArgs e)
		{
			// Form Initialization routine
			DisplayMessage("Program Ready");
			cbPort.Items.Add("USB1");
			cbPort.Items.Add("USB2");
			cbPort.Items.Add("USB3");
			cbPort.Items.Add("USB4");
			cbPort.Items.Add("USB5");
			cbPort.Items.Add("USB6");
			cbPort.Items.Add("USB7");
			cbPort.Items.Add("USB8");
			cbPort.SelectedIndex = 0;
		}

		private void btnConnect_Click(object sender, System.EventArgs e)
		{
		
			//=====================================================================
			// This function opens the port(connection) to ACR120 reader
			//=====================================================================
		
			// Variable declarations
			int ctr = 0;
			byte[] FirmwareVer = new byte[31];
			byte[] FirmwareVer1 = new byte[20];
			byte infolen = 0x00;
			string FirmStr;
			ACR120U.tReaderStatus ReaderStat = new ACR120U.tReaderStatus();

			if (g_isConnected)
			{
			
				DisplayMessage("Device is already connected.");
				return;

			}

			g_rHandle = ACR120U.ACR120_Open(cbPort.SelectedIndex);
			if (g_rHandle != 0)

				DisplayMessage("[X] " + ACR120U.GetErrMsg(g_rHandle));
					
			else
			{
				
				DisplayMessage("Connected to USB" + string.Format("{0}", cbPort.SelectedIndex+1));
				g_isConnected = true;

				//Get the DLL version the program is using
				g_retCode = ACR120U.ACR120_RequestDLLVersion(ref infolen, ref FirmwareVer[0]);
				if (g_retCode < 0)

					DisplayMessage("[X] " + ACR120U.GetErrMsg(g_retCode));
					
				else
				{
					FirmStr = "";
					for(ctr=0;ctr<Convert.ToInt16(infolen)-1;ctr++)
						FirmStr = FirmStr + char.ToString((char)(FirmwareVer[ctr]));
					DisplayMessage("DLL Version : " + FirmStr);
				}
    
				//Routine to get the firmware version.
				g_retCode = ACR120U.ACR120_Status(g_rHandle, ref FirmwareVer1[0], ref ReaderStat);
				if (g_retCode < 0)

					DisplayMessage("[X] " + ACR120U.GetErrMsg(g_retCode));
					
				else
				{
					FirmStr = "";
					for(ctr=0;ctr<Convert.ToInt16(infolen);ctr++)
						if ((FirmwareVer1[ctr] != 0x00) && (FirmwareVer1[ctr] != 0xFF))
							FirmStr = FirmStr + char.ToString((char)(FirmwareVer1[ctr]));
					DisplayMessage("Firmware Version : " + FirmStr);
				}

			}

		}

		private void btnSelect_Click(object sender, System.EventArgs e)
		{

			//=====================================================================
			// This function selects a single card in range and return the Serial No.
			//=====================================================================
    
			//Variable Declarations
			byte[] ResultSN = new byte[11];
			byte ResultTag = 0x00;
			byte[] TagType = new byte[51];
			int ctr=0;
			string SN = "";


			//Select specific card based from serial number	
			g_retCode = ACR120U.ACR120_Select(g_rHandle, ref TagType[0], ref ResultTag, ref ResultSN[0]);
			if (g_retCode < 0)

				DisplayMessage("[X] " + ACR120U.GetErrMsg(g_retCode));
					
			else
			{
				DisplayMessage("Select Success");
				//get serial number and convert to hex
              
				if ((TagType[0] == 4) || (TagType[0] == 5))
				{

					SN = "";
					for (ctr=0; ctr<7;ctr++)
					{
						SN = SN + string.Format("{0:X2} ",ResultSN[ctr]);
					}

				}
				else
				{

					SN = "";
					for (ctr=0; ctr<ResultTag;ctr++)
					{
						SN = SN + string.Format("{0:X2} ",ResultSN[ctr]);
					}

				}
          
				//Display Serial Number
				DisplayMessage("( i ) Card Serial Number: " + SN + " ( " + ACR120U.GetTagType1(TagType[0]) + " )");
			}

		}

		private void btnTxDT_Click(object sender, System.EventArgs e)
		{
			//=======================================================================
			// This function transfer user specific data frames.
			//=======================================================================

			//Variable Declarations

			TxDataForm TxData = new TxDataForm();
			if (TxData.ShowDialog() == DialogResult.Cancel)
				return;
		}

		private void btnReset_Click(object sender, System.EventArgs e)
		{

			// Reset Reader to Station ID specified

			g_retCode = ACR120U.ACR120_Reset(g_rHandle);

			if (g_retCode < 0)
	
				DisplayMessage("[X] " + ACR120U.GetErrMsg(g_retCode));
					
			else

				DisplayMessage("Reset Station Success");
			
		}

		private void btnPOn_Click(object sender, System.EventArgs e)
		{

			//=====================================================================
			// This function turns the device power on
			//=====================================================================

			g_retCode = ACR120U.ACR120_Power(g_rHandle, 1);  
			if (g_retCode < 0)

				DisplayMessage("[X] " + ACR120U.GetErrMsg(g_retCode));
					
			else
				
				DisplayMessage("Device Power On Success");

		}

		private void btnPOff_Click(object sender, System.EventArgs e)
		{

			//=====================================================================
			// This function turns the device power off
			//=====================================================================

			g_retCode = ACR120U.ACR120_Power(g_rHandle, 0);  
			if (g_retCode < 0)

				DisplayMessage("[X] " + ACR120U.GetErrMsg(g_retCode));
					
			else
				
				DisplayMessage("Device Power Off Success");

		}
	}
}
