//  Copyright(C):      Advanced Card Systems Ltd
//
//  File:              ACR120 Write Master Key Sample.csproj
//
//  Description:       Write Master Key sample code for 
//					   ACR120 USB Contactless Reader.
//
//  Author:	           Jose Isagani R. Mission
//
//  Date:	           August 16, 2006
//
//  Revision Trail:   (Date/Author/Description)
//                     December 11, 2007/ Aileen Grace L. Sarte/ Converted to Visual C# 2005
//
//===========================================================================================
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace ACR120_Write_Master_Key_Sample
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{

		private int g_rHandle, g_retCode;
		private byte g_Sec;
		private byte[] g_pKey = new byte[6];
		private bool g_isConnected = false;

		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.ListBox lbMessage;
		private System.Windows.Forms.GroupBox gbConnect;
		private System.Windows.Forms.GroupBox gbFunction;
		private System.Windows.Forms.Button btnClrDisp;
		private System.Windows.Forms.Button btnQuit;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.ComboBox cbPort;
		private System.Windows.Forms.Button btnConnect;
		private System.Windows.Forms.Button btnSelect;
		private System.Windows.Forms.Button btnLogin;
		private System.Windows.Forms.Button btnWriteKey;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox tStoredNo;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.TextBox tMKey1;
		private System.Windows.Forms.TextBox tMKey2;
		private System.Windows.Forms.TextBox tMKey3;
		private System.Windows.Forms.TextBox tMKey4;
		private System.Windows.Forms.TextBox tMKey5;
		private System.Windows.Forms.TextBox tMKey6;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.TextBox textBox2;
		private System.Windows.Forms.TextBox textBox3;
		private System.Windows.Forms.TextBox textBox4;
		private System.Windows.Forms.TextBox textBox5;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		private void DisplayMessage(string Message)
		{
			lbMessage.Items.Add(Message);
			lbMessage.SelectedIndex = lbMessage.Items.Count - 1;
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainForm));
			this.panel1 = new System.Windows.Forms.Panel();
			this.gbFunction = new System.Windows.Forms.GroupBox();
			this.tMKey6 = new System.Windows.Forms.TextBox();
			this.tMKey5 = new System.Windows.Forms.TextBox();
			this.tMKey4 = new System.Windows.Forms.TextBox();
			this.tMKey3 = new System.Windows.Forms.TextBox();
			this.tMKey2 = new System.Windows.Forms.TextBox();
			this.tMKey1 = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.tStoredNo = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.btnWriteKey = new System.Windows.Forms.Button();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.textBox2 = new System.Windows.Forms.TextBox();
			this.textBox3 = new System.Windows.Forms.TextBox();
			this.textBox4 = new System.Windows.Forms.TextBox();
			this.textBox5 = new System.Windows.Forms.TextBox();
			this.gbConnect = new System.Windows.Forms.GroupBox();
			this.btnLogin = new System.Windows.Forms.Button();
			this.btnSelect = new System.Windows.Forms.Button();
			this.btnConnect = new System.Windows.Forms.Button();
			this.cbPort = new System.Windows.Forms.ComboBox();
			this.label1 = new System.Windows.Forms.Label();
			this.lbMessage = new System.Windows.Forms.ListBox();
			this.btnClrDisp = new System.Windows.Forms.Button();
			this.btnQuit = new System.Windows.Forms.Button();
			this.panel1.SuspendLayout();
			this.gbFunction.SuspendLayout();
			this.gbConnect.SuspendLayout();
			this.SuspendLayout();
			// 
			// panel1
			// 
			this.panel1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.panel1.Controls.Add(this.gbFunction);
			this.panel1.Controls.Add(this.gbConnect);
			this.panel1.Controls.Add(this.lbMessage);
			this.panel1.Location = new System.Drawing.Point(8, 8);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(528, 400);
			this.panel1.TabIndex = 0;
			// 
			// gbFunction
			// 
			this.gbFunction.Controls.Add(this.tMKey6);
			this.gbFunction.Controls.Add(this.tMKey5);
			this.gbFunction.Controls.Add(this.tMKey4);
			this.gbFunction.Controls.Add(this.tMKey3);
			this.gbFunction.Controls.Add(this.tMKey2);
			this.gbFunction.Controls.Add(this.tMKey1);
			this.gbFunction.Controls.Add(this.label3);
			this.gbFunction.Controls.Add(this.tStoredNo);
			this.gbFunction.Controls.Add(this.label2);
			this.gbFunction.Controls.Add(this.btnWriteKey);
			this.gbFunction.Controls.Add(this.textBox1);
			this.gbFunction.Controls.Add(this.textBox2);
			this.gbFunction.Controls.Add(this.textBox3);
			this.gbFunction.Controls.Add(this.textBox4);
			this.gbFunction.Controls.Add(this.textBox5);
			this.gbFunction.Location = new System.Drawing.Point(240, 192);
			this.gbFunction.Name = "gbFunction";
			this.gbFunction.Size = new System.Drawing.Size(272, 192);
			this.gbFunction.TabIndex = 16;
			this.gbFunction.TabStop = false;
			this.gbFunction.Text = "Functions";
			// 
			// tMKey6
			// 
			this.tMKey6.CharacterCasing = System.Windows.Forms.CharacterCasing.Upper;
			this.tMKey6.Location = new System.Drawing.Point(224, 104);
			this.tMKey6.Name = "tMKey6";
			this.tMKey6.Size = new System.Drawing.Size(32, 21);
			this.tMKey6.TabIndex = 10;
			this.tMKey6.Text = "FF";
			this.tMKey6.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.tMKey6.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.tMKey1_KeyPress);
			// 
			// tMKey5
			// 
			this.tMKey5.CharacterCasing = System.Windows.Forms.CharacterCasing.Upper;
			this.tMKey5.Location = new System.Drawing.Point(184, 104);
			this.tMKey5.Name = "tMKey5";
			this.tMKey5.Size = new System.Drawing.Size(32, 21);
			this.tMKey5.TabIndex = 9;
			this.tMKey5.Text = "FF";
			this.tMKey5.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.tMKey5.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.tMKey1_KeyPress);
			this.tMKey5.KeyUp += new System.Windows.Forms.KeyEventHandler(this.tMKey5_KeyUp);
			// 
			// tMKey4
			// 
			this.tMKey4.CharacterCasing = System.Windows.Forms.CharacterCasing.Upper;
			this.tMKey4.Location = new System.Drawing.Point(144, 104);
			this.tMKey4.Name = "tMKey4";
			this.tMKey4.Size = new System.Drawing.Size(32, 21);
			this.tMKey4.TabIndex = 8;
			this.tMKey4.Text = "FF";
			this.tMKey4.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.tMKey4.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.tMKey1_KeyPress);
			this.tMKey4.KeyUp += new System.Windows.Forms.KeyEventHandler(this.tMKey4_KeyUp);
			// 
			// tMKey3
			// 
			this.tMKey3.CharacterCasing = System.Windows.Forms.CharacterCasing.Upper;
			this.tMKey3.Location = new System.Drawing.Point(224, 72);
			this.tMKey3.Name = "tMKey3";
			this.tMKey3.Size = new System.Drawing.Size(32, 21);
			this.tMKey3.TabIndex = 7;
			this.tMKey3.Text = "FF";
			this.tMKey3.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.tMKey3.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.tMKey1_KeyPress);
			this.tMKey3.KeyUp += new System.Windows.Forms.KeyEventHandler(this.tMKey3_KeyUp);
			// 
			// tMKey2
			// 
			this.tMKey2.CharacterCasing = System.Windows.Forms.CharacterCasing.Upper;
			this.tMKey2.Location = new System.Drawing.Point(184, 72);
			this.tMKey2.Name = "tMKey2";
			this.tMKey2.Size = new System.Drawing.Size(32, 21);
			this.tMKey2.TabIndex = 6;
			this.tMKey2.Text = "FF";
			this.tMKey2.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.tMKey2.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.tMKey1_KeyPress);
			this.tMKey2.KeyUp += new System.Windows.Forms.KeyEventHandler(this.tMKey2_KeyUp);
			// 
			// tMKey1
			// 
			this.tMKey1.CharacterCasing = System.Windows.Forms.CharacterCasing.Upper;
			this.tMKey1.Location = new System.Drawing.Point(144, 72);
			this.tMKey1.Name = "tMKey1";
			this.tMKey1.Size = new System.Drawing.Size(32, 21);
			this.tMKey1.TabIndex = 5;
			this.tMKey1.Text = "FF";
			this.tMKey1.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.tMKey1.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.tMKey1_KeyPress);
			this.tMKey1.KeyUp += new System.Windows.Forms.KeyEventHandler(this.tMKey1_KeyUp);
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(24, 75);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(104, 16);
			this.label3.TabIndex = 18;
			this.label3.Text = "Keys (Hexadecimal)";
			// 
			// tStoredNo
			// 
			this.tStoredNo.Location = new System.Drawing.Point(144, 32);
			this.tStoredNo.MaxLength = 2;
			this.tStoredNo.Name = "tStoredNo";
			this.tStoredNo.Size = new System.Drawing.Size(64, 21);
			this.tStoredNo.TabIndex = 4;
			this.tStoredNo.Text = "30";
			this.tStoredNo.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.tStoredNo.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.tStoredNo_KeyPress);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(24, 35);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(112, 16);
			this.label2.TabIndex = 17;
			this.label2.Text = "Stored No (Decimal)";
			// 
			// btnWriteKey
			// 
			this.btnWriteKey.Location = new System.Drawing.Point(152, 144);
			this.btnWriteKey.Name = "btnWriteKey";
			this.btnWriteKey.Size = new System.Drawing.Size(104, 23);
			this.btnWriteKey.TabIndex = 11;
			this.btnWriteKey.Text = "&Write Master Key";
			this.btnWriteKey.Click += new System.EventHandler(this.btnWriteKey_Click);
			// 
			// textBox1
			// 
			this.textBox1.Location = new System.Drawing.Point(224, 104);
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(32, 21);
			this.textBox1.TabIndex = 9;
			this.textBox1.Text = "FF";
			this.textBox1.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// textBox2
			// 
			this.textBox2.Location = new System.Drawing.Point(184, 104);
			this.textBox2.Name = "textBox2";
			this.textBox2.Size = new System.Drawing.Size(32, 21);
			this.textBox2.TabIndex = 8;
			this.textBox2.Text = "FF";
			this.textBox2.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// textBox3
			// 
			this.textBox3.Location = new System.Drawing.Point(184, 72);
			this.textBox3.Name = "textBox3";
			this.textBox3.Size = new System.Drawing.Size(32, 21);
			this.textBox3.TabIndex = 5;
			this.textBox3.Text = "FF";
			this.textBox3.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// textBox4
			// 
			this.textBox4.Location = new System.Drawing.Point(144, 72);
			this.textBox4.Name = "textBox4";
			this.textBox4.Size = new System.Drawing.Size(32, 21);
			this.textBox4.TabIndex = 4;
			this.textBox4.Text = "FF";
			this.textBox4.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// textBox5
			// 
			this.textBox5.Location = new System.Drawing.Point(224, 72);
			this.textBox5.Name = "textBox5";
			this.textBox5.Size = new System.Drawing.Size(32, 21);
			this.textBox5.TabIndex = 6;
			this.textBox5.Text = "FF";
			this.textBox5.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// gbConnect
			// 
			this.gbConnect.Controls.Add(this.btnLogin);
			this.gbConnect.Controls.Add(this.btnSelect);
			this.gbConnect.Controls.Add(this.btnConnect);
			this.gbConnect.Controls.Add(this.cbPort);
			this.gbConnect.Controls.Add(this.label1);
			this.gbConnect.Location = new System.Drawing.Point(8, 192);
			this.gbConnect.Name = "gbConnect";
			this.gbConnect.Size = new System.Drawing.Size(224, 192);
			this.gbConnect.TabIndex = 15;
			this.gbConnect.TabStop = false;
			this.gbConnect.Text = "Connection";
			// 
			// btnLogin
			// 
			this.btnLogin.Location = new System.Drawing.Point(112, 152);
			this.btnLogin.Name = "btnLogin";
			this.btnLogin.Size = new System.Drawing.Size(96, 23);
			this.btnLogin.TabIndex = 3;
			this.btnLogin.Text = "&Login";
			this.btnLogin.Click += new System.EventHandler(this.btnLogin_Click);
			// 
			// btnSelect
			// 
			this.btnSelect.Location = new System.Drawing.Point(112, 112);
			this.btnSelect.Name = "btnSelect";
			this.btnSelect.Size = new System.Drawing.Size(96, 23);
			this.btnSelect.TabIndex = 2;
			this.btnSelect.Text = "&Select";
			this.btnSelect.Click += new System.EventHandler(this.btnSelect_Click);
			// 
			// btnConnect
			// 
			this.btnConnect.Location = new System.Drawing.Point(112, 72);
			this.btnConnect.Name = "btnConnect";
			this.btnConnect.Size = new System.Drawing.Size(96, 23);
			this.btnConnect.TabIndex = 1;
			this.btnConnect.Text = "&Connect";
			this.btnConnect.Click += new System.EventHandler(this.btnConnect_Click);
			// 
			// cbPort
			// 
			this.cbPort.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cbPort.Location = new System.Drawing.Point(88, 32);
			this.cbPort.Name = "cbPort";
			this.cbPort.Size = new System.Drawing.Size(120, 21);
			this.cbPort.TabIndex = 0;
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.ForeColor = System.Drawing.Color.Navy;
			this.label1.Location = new System.Drawing.Point(16, 37);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(72, 23);
			this.label1.TabIndex = 0;
			this.label1.Text = "Select Port";
			this.label1.Click += new System.EventHandler(this.label1_Click);
			// 
			// lbMessage
			// 
			this.lbMessage.Location = new System.Drawing.Point(8, 8);
			this.lbMessage.Name = "lbMessage";
			this.lbMessage.Size = new System.Drawing.Size(507, 173);
			this.lbMessage.TabIndex = 14;
			// 
			// btnClrDisp
			// 
			this.btnClrDisp.Location = new System.Drawing.Point(280, 424);
			this.btnClrDisp.Name = "btnClrDisp";
			this.btnClrDisp.Size = new System.Drawing.Size(112, 23);
			this.btnClrDisp.TabIndex = 12;
			this.btnClrDisp.Text = "Clear &Display";
			this.btnClrDisp.Click += new System.EventHandler(this.btnClrDisp_Click);
			// 
			// btnQuit
			// 
			this.btnQuit.Location = new System.Drawing.Point(416, 424);
			this.btnQuit.Name = "btnQuit";
			this.btnQuit.Size = new System.Drawing.Size(112, 23);
			this.btnQuit.TabIndex = 13;
			this.btnQuit.Text = "&Quit";
			this.btnQuit.Click += new System.EventHandler(this.btnQuit_Click);
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.ClientSize = new System.Drawing.Size(544, 462);
			this.Controls.Add(this.btnQuit);
			this.Controls.Add(this.btnClrDisp);
			this.Controls.Add(this.panel1);
			this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "MainForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Write Master Key Sample";
			this.Load += new System.EventHandler(this.MainForm_Load);
			this.panel1.ResumeLayout(false);
			this.gbFunction.ResumeLayout(false);
			this.gbConnect.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}

		private void btnClrDisp_Click(object sender, System.EventArgs e)
		{
			lbMessage.Items.Clear();
		}

		private void btnQuit_Click(object sender, System.EventArgs e)
		{
			ACR120U.ACR120_Close(g_rHandle);
			Application.Exit();
		}

		private void label1_Click(object sender, System.EventArgs e)
		{
		
		}

		private void MainForm_Load(object sender, System.EventArgs e)
		{
			// Form Initialization routine
			DisplayMessage("Program Ready");
			cbPort.Items.Add("USB1");
			cbPort.Items.Add("USB2");
			cbPort.Items.Add("USB3");
			cbPort.Items.Add("USB4");
			cbPort.Items.Add("USB5");
			cbPort.Items.Add("USB6");
			cbPort.Items.Add("USB7");
			cbPort.Items.Add("USB8");
			cbPort.SelectedIndex = 0;
		}

		private void btnConnect_Click(object sender, System.EventArgs e)
		{
		
			//=====================================================================
			// This function opens the port(connection) to ACR120 reader
			//=====================================================================
		
			// Variable declarations
			int ctr = 0;
			byte[] FirmwareVer = new byte[31];
			byte[] FirmwareVer1 = new byte[20];
			byte infolen = 0x00;
			string FirmStr;
			ACR120U.tReaderStatus ReaderStat = new ACR120U.tReaderStatus();

			if (g_isConnected)
			{
			
				DisplayMessage("Device is already connected.");
				return;

			}

			g_rHandle = ACR120U.ACR120_Open(cbPort.SelectedIndex);
			if (g_rHandle != 0)

				DisplayMessage("[X] " + ACR120U.GetErrMsg(g_rHandle));
					
			else
			{
				
				DisplayMessage("Connected to USB" + string.Format("{0}", cbPort.SelectedIndex+1));
				g_isConnected = true;

				//Get the DLL version the program is using
				g_retCode = ACR120U.ACR120_RequestDLLVersion(ref infolen, ref FirmwareVer[0]);
				if (g_retCode < 0)

					DisplayMessage("[X] " + ACR120U.GetErrMsg(g_retCode));
					
				else
				{
					FirmStr = "";
					for(ctr=0;ctr<Convert.ToInt16(infolen)-1;ctr++)
						FirmStr = FirmStr + char.ToString((char)(FirmwareVer[ctr]));
					DisplayMessage("DLL Version : " + FirmStr);
				}
    
				//Routine to get the firmware version.
				g_retCode = ACR120U.ACR120_Status(g_rHandle, ref FirmwareVer1[0], ref ReaderStat);
				if (g_retCode < 0)

					DisplayMessage("[X] " + ACR120U.GetErrMsg(g_retCode));
					
				else
				{
					FirmStr = "";
					for(ctr=0;ctr<Convert.ToInt16(infolen);ctr++)
						if ((FirmwareVer1[ctr] != 0x00) && (FirmwareVer1[ctr] != 0xFF))
							FirmStr = FirmStr + char.ToString((char)(FirmwareVer1[ctr]));
					DisplayMessage("Firmware Version : " + FirmStr);
				}

			}

		}

		private void btnSelect_Click(object sender, System.EventArgs e)
		{

			//=====================================================================
			// This function selects a single card in range and return the Serial No.
			//=====================================================================
    
			//Variable Declarations
			byte[] ResultSN = new byte[11];
			byte ResultTag = 0x00;
			byte[] TagType = new byte[51];
			int ctr=0;
			string SN = "";


			//Select specific card based from serial number	
			g_retCode = ACR120U.ACR120_Select(g_rHandle, ref TagType[0], ref ResultTag, ref ResultSN[0]);
			if (g_retCode < 0)

				DisplayMessage("[X] " + ACR120U.GetErrMsg(g_retCode));
					
			else
			{
				DisplayMessage("Select Success");
				//get serial number and convert to hex
              
				if ((TagType[0] == 4) || (TagType[0] == 5))
				{

					SN = "";
					for (ctr=0; ctr<7;ctr++)
					{
						SN = SN + string.Format("{0:X2} ",ResultSN[ctr]);
					}

				}
				else
				{

					SN = "";
					for (ctr=0; ctr<ResultTag;ctr++)
					{
						SN = SN + string.Format("{0:X2} ",ResultSN[ctr]);
					}

				}
          
				//Display Serial Number
				DisplayMessage("( i ) Card Serial Number: " + SN + " ( " + ACR120U.GetTagType1(TagType[0]) + " )");
			}

		}

		private void btnLogin_Click(object sender, System.EventArgs e)
		{
			
			//=====================================================================
			// This function is for the authentication to access one sector of a card.
			// Only one sector at a time can be accessed.
			//=====================================================================
			
			long sto = 0;
			byte vKeyType = 0x00;
			int ctr, tmpInt, PhysicalSector = 0;

			Login loginForm = new Login();
			if (loginForm.ShowDialog() == DialogResult.Cancel)
				return;

			switch (loginForm.cbLoginType.SelectedIndex)
			{

				case 0: vKeyType = ACR120U.ACR120_LOGIN_KEYTYPE_A;
					break;
				case 1: vKeyType = ACR120U.ACR120_LOGIN_KEYTYPE_B;
					break;
				case 2: vKeyType = ACR120U.ACR120_LOGIN_KEYTYPE_DEFAULT_A;
					break;
				case 3: vKeyType = ACR120U.ACR120_LOGIN_KEYTYPE_DEFAULT_B;
					break;
				case 4: vKeyType = ACR120U.ACR120_LOGIN_KEYTYPE_DEFAULT_F;
					break;
				case 5: vKeyType = ACR120U.ACR120_LOGIN_KEYTYPE_STORED_A;
					break;
				case 6: vKeyType = ACR120U.ACR120_LOGIN_KEYTYPE_STORED_B;
					break;

			}

			switch (loginForm.cbLoginType.SelectedIndex)
			{

				case 0:
				case 1:
					g_pKey[0] = Convert.ToByte(loginForm.tKey1.Text  ,16);
					g_pKey[1] = Convert.ToByte(loginForm.tKey2.Text  ,16);
					g_pKey[2] = Convert.ToByte(loginForm.tKey3.Text  ,16);
					g_pKey[3] = Convert.ToByte(loginForm.tKey4.Text  ,16);
					g_pKey[4] = Convert.ToByte(loginForm.tKey5.Text  ,16);
					g_pKey[5] = Convert.ToByte(loginForm.tKey6.Text  ,16);
					break;
				case 2:
				case 3:
				case 4:
					for(ctr=0;ctr<6;ctr++)
						g_pKey[ctr] = 0xFF;
					break;
				case 5:
				case 6:
					sto = Convert.ToInt32(loginForm.tStoredNo.Text);
					break;
			
			}

			tmpInt = Convert.ToInt16(loginForm.tSector.Text);
			g_Sec = Convert.ToByte(tmpInt);

			//Computation for obtaining the actual Physical Sector.
			if (Convert.ToInt16(g_Sec) > 31)
				PhysicalSector = Convert.ToInt16(g_Sec) + ((Convert.ToInt16(g_Sec) - 32) * 3);
			else
				PhysicalSector = Convert.ToInt16(g_Sec);

			g_retCode = ACR120U.ACR120_Login(g_rHandle, Convert.ToByte(PhysicalSector), Convert.ToInt16(vKeyType),
				Convert.ToByte(sto), ref g_pKey[0]);
			if (g_retCode < 0)
	
				DisplayMessage("[X] " + ACR120U.GetErrMsg(g_retCode));
					
			else
			{
				DisplayMessage("Login Success");
				DisplayMessage("Log at Logical Sector: " + String.Format("{0}", Convert.ToInt16(g_Sec)));
				DisplayMessage("Log at Physical Sector: " + String.Format("{0}", PhysicalSector));
				DisplayMessage("Login Type index: " + string.Format("{0}", loginForm.cbLoginType.SelectedIndex));

			}

		}

		private void tStoredNo_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
		{
			if (e.KeyChar < 48 || e.KeyChar  > 57)
				if (e.KeyChar != (char)(Keys.Back))
					e.Handled = true;
		}

		private void tMKey1_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
		{
			if (e.KeyChar < 97 || e.KeyChar  > 102)
				if (e.KeyChar < 48 || e.KeyChar  > 57)
					if (e.KeyChar < 65 || e.KeyChar > 70)
						if (e.KeyChar != (char)(Keys.Back))
							e.Handled = true;
		}

		private void tMKey1_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if (tMKey1.Text.Length == 2)
				tMKey2.Focus(); 
		}

		private void tMKey2_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if (tMKey2.Text.Length == 2)
				tMKey3.Focus(); 
		}

		private void tMKey3_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if (tMKey3.Text.Length == 2)
				tMKey4.Focus(); 
		}

		private void tMKey4_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if (tMKey4.Text.Length == 2)
				tMKey5.Focus(); 
		}

		private void tMKey5_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if (tMKey5.Text.Length == 2)
				tMKey6.Focus(); 
		}

		private void btnWriteKey_Click(object sender, System.EventArgs e)
		{
		
			//=====================================================================
			// This function writes Master key to internal EEPROM of the reader.
			//=====================================================================
    
			//Variable Declarations
			byte[] skey = new byte[6];
			byte STONum = 0x00;
			string newKey = "";
			int ctr = 0;

			// Validate input
			if (tStoredNo.Text == "")
			{
				tStoredNo.Focus();
				return;
			}
			if (Convert.ToInt16(tStoredNo.Text) > 31)
			{
				tStoredNo.Text = "31";
				tStoredNo.Focus();
				return;
			}
			if (tMKey1.Text.Length < 2)
			{
				tMKey1.Focus();
				return;
			}
			if (tMKey2.Text.Length < 2)
			{
				tMKey2.Focus();
				return;
			}
			if (tMKey3.Text.Length < 2)
			{
				tMKey3.Focus();
				return;
			}
			if (tMKey4.Text.Length < 2)
			{
				tMKey4.Focus();
				return;
			}
			if (tMKey5.Text.Length < 2)
			{
				tMKey5.Focus();
				return;
			}
			if (tMKey6.Text.Length < 2)
			{
				tMKey6.Focus();
				return;
			}

			//assign storage number to stonum variable
			STONum = Convert.ToByte(tStoredNo.Text);

			//Put Keys in an array Variable (converted to decimal)
			skey[0] = Convert.ToByte(tMKey1.Text, 16);
			skey[1] = Convert.ToByte(tMKey2.Text, 16);
			skey[2] = Convert.ToByte(tMKey3.Text, 16);
			skey[3] = Convert.ToByte(tMKey4.Text, 16);
			skey[4] = Convert.ToByte(tMKey5.Text, 16);
			skey[5] = Convert.ToByte(tMKey6.Text, 16);

			g_retCode = ACR120U.ACR120_WriteMasterKey(g_rHandle, STONum, ref skey[0]);
			if (g_retCode < 0)
	
				DisplayMessage("[X] " + ACR120U.GetErrMsg(g_retCode));
					
			else
			{
				
				DisplayMessage("Write Master Key Success");
				for(ctr=0;ctr<6;ctr++)
					newKey = newKey + String.Format("{0:X2} ", skey[ctr]);
				DisplayMessage("New Master Key: " + newKey);

			}

		}

	}
}
